// Copyright (C) 1998-1999 Scott Cutler
// Please see the "readme.txt" file for license details

class Tex {
public:
	Tex(const uint32, const XGLTexture &);
	~Tex();

	const LPDIRECT3DTEXTURE2 tex() { return _tex; }
	const uint32 base() const { return _base; }
	const uint32 width() const { return _width; }
	const uint32 height() const { return _height; }
	const uint32 aspect() const { return _aspect; }
	const int sameformat(const XGLTexture &t) {
//		return (_width == t._width && _height == t._height && _format == t._format);
		return 0;
	}

	const uint32 paletted() const { return _paletted; }

	void createpalette();
	void setpalette();
	void setcolorkey(void (*)(uchar *, uchar *));
	void copytexture(const XGLTexture &);

private:
	uint32 _base, _width, _height, _paletted;
	uint32 _bpp, _sbpp, _format;
	int _palnum;
	char *_data;
	LPDIRECTDRAWSURFACE4 _texDDS;
	LPDIRECT3DTEXTURE2 _tex;
	uint32 _aspect;
	void (*_texcc)(uchar *, uchar *);
};

uint32 intersect(const Tex &, const Tex &);